Skip to main content

Clerk Billing for B2B SaaS

Important

Billing regularly introduces new features and UI changes to Clerk's components. If you'd like to remain on a specific version of Clerk's components or SDK, you can follow the steps in the pinning documentation.

Clerk Billing for B2B SaaS allows you to create Plans and manage Subscriptions for companies or organizations in your application. If you'd like to charge individual users, see Billing for B2C SaaS. You can also combine both B2C and B2B Billing in the same application.

Enable Billing

To enable Billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling Billing for your application.

Clerk Billing costs the same as using Stripe Billing directly, just 0.7% per transaction, plus transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.

Payment gateway

Once you have enabled Billing, you will see the following Payment gateway options for collecting payments via Stripe:

  • Clerk development gateway: A shared test Stripe account used for development instances. This allows developers to test and build Billing flows in development without needing to create and configure a Stripe account.
  • Stripe account: Use your own Stripe account for production. A Stripe account created for a development instance cannot be used for production. You will need to create a separate Stripe account for your production environment.

Create a Plan

Subscription Plans are what your customers subscribe to. There is no limit to the number of Plans you can create. If your Clerk instance has existing Custom Permissions, the corresponding Features from those Permissions will automatically be added to the Free Plan for Organizations. This ensures that Organization members get the same set of Custom Permissions when Billing is enabled, because all Organizations start on the Free Plan.

To create a Plan, navigate to the Subscription plans page in the Clerk Dashboard. Here, you can create, edit, and delete Plans. To setup B2B Billing, select the Plans for Organizations tab and select Add Plan. When creating a Plan, you can also create Features for the Plan; see the next section for more information.

Tip

What is the Publicly available option?

Add Features to a Plan

Features make it easy to give entitlements to your Plans. You can add any number of Features to a Plan.

You can add a Feature to a Plan when you are creating a Plan. To add it after a Plan is created:

  1. In the Clerk Dashboard, navigate to the Subscription plans page.
  2. Select the Plan you'd like to add a Feature to.
  3. In the Features section, select Add Feature.

Tip

What is the Publicly available option?

Create a pricing page

You can create a pricing page by using the <PricingTable /> component. This component displays a table of Plans and Features that customers can subscribe to. It's recommended to create a dedicated page, as shown in the following example.

src/screens/pricing.tsx
import { PricingTable } from '@clerk/react'

export default function PricingScreen() {
  return (
    <div style={{ maxWidth: '800px', margin: '0 auto', padding: '0 1rem' }}>
      <PricingTable for="organization" />
    </div>
  )
}

Control access with Features, Plans, and Permissions

You can use Clerk's Features, Plans, and Permissions to gate access to content using . There are a few ways to do this, but the recommended approach is to either use the has() method or the <Show> component.

Important

Permission-based authorization checks link with Feature-based authorization checks. This means that if you are checking a Custom Permission, it will only work if the Feature part of the Permission key (org:<feature>:<permission>) is a Feature included in the Organization's active Plan. For example, say you want to check if an Organization member has the Custom Permission org:teams:manage, where teams is the Feature. Before performing the authorization check, you need to ensure that the user's Organization is subscribed to a Plan that has the teams Feature. If the user's Organization is not subscribed to a Plan that has the teams Feature, the authorization check will always return false, even if the user has the Custom Permission.

Example: Using has()

Use the has() method to test if the Organization has access to a Plan:

const hasPremiumAccess = has({ plan: 'gold' })

Or a Feature:

const hasPremiumAccess = has({ feature: 'widgets' })

The has() method is a server-side helper that checks if the Organization has been granted a specific type of access control (Role, Permission, Feature, or Plan) and returns a boolean value. has() is available on the auth object, which you will access differently depending on the framework you are using.

Tip

Why aren't Custom Permissions appearing in the session token (JWT) or in API responses (including the result of the has() check)?

The following example demonstrates how to use has() to check if an Organization has a Plan.

src/pages/bronze-content.tsx
import { useAuth } from '@clerk/react'

export default function BronzeContentPage() {
  const { has, isLoaded } = useAuth()

  if (!isLoaded) return <div>Loading...</div>

  const hasBronzePlan = has({ plan: 'bronze' })

  if (!hasBronzePlan) return <h1>Only subscribers to the Bronze plan can access this content.</h1>

  return <h1>For Bronze subscribers only</h1>
}

The following example demonstrates how to use has() to check if an Organization has a Feature.

src/pages/premium-content.tsx
import { useAuth } from '@clerk/react'

export default function PremiumContentPage() {
  const { isLoaded, has } = useAuth()

  if (!isLoaded) return <div>Loading...</div>

  const hasPremiumAccess = has({ feature: 'premium_access' })

  if (!hasPremiumAccess)
    return <h1>Only subscribers with the Premium Access feature can access this content.</h1>

  return <h1>Our Exclusive Content</h1>
}

The following example demonstrates how to use has() to check if an Organization has a Permission.

src/pages/manage-premium-content.tsx
import { useAuth } from '@clerk/react'

export default function ManagePremiumContentPage() {
  const { has, isLoaded } = useAuth()

  if (!isLoaded) return <div>Loading...</div>

  const hasPremiumAccessManage = has({ permission: 'org:premium_access:manage' })

  if (!hasPremiumAccessManage)
    return (
      <h1>Only subscribers with the Premium Access Manage permission can access this content.</h1>
    )

  return <h1>Our Exclusive Content</h1>
}

Example: Using <Show>

The <Show> component can be used to protect content or even entire routes by checking if the Organization has been granted a specific type of access control (Role, Permission, Feature, or Plan). You can pass a fallback prop to <Show> that will be rendered if the Organization does not have the access control.

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Plan.

src/pages/protected-content.tsx
import { Show } from '@clerk/react'

export default function ProtectedContentPage() {
  return (
    <Show
      when={{ plan: 'bronze' }}
      fallback={<p>Only subscribers to the Bronze plan can access this content.</p>}
    >
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Show>
  )
}

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Feature.

src/pages/protected-premium-content.tsx
import { Show } from '@clerk/react'

export default function ProtectedPremiumContentPage() {
  return (
    <Show
      when={{ feature: 'premium_access' }}
      fallback="Only subscribers with the Premium Access feature can access this content."
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Show>
  )
}

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Permission.

src/pages/protected-manage-content.tsx
import { Show } from '@clerk/react'

export default function ProtectedManageContentPage() {
  return (
    <Show
      when={{ permission: 'org:premium_access:manage' }}
      fallback={
        <p>Only subscribers with the Premium Access Manage permission can access this content.</p>
      }
    >
      <h1>Exclusive Management Content</h1>
      <p>This content is only visible to users with Premium Access Manage permission.</p>
    </Show>
  )
}

Feedback

What did you think of this content?

Last updated on

Skip to main content

Clerk Billing for B2B SaaS

Important

Billing regularly introduces new features and UI changes to Clerk's components. If you'd like to remain on a specific version of Clerk's components or SDK, you can follow the steps in the pinning documentation.

Clerk Billing for B2B SaaS allows you to create Plans and manage Subscriptions for companies or organizations in your application. If you'd like to charge individual users, see Billing for B2C SaaS. You can also combine both B2C and B2B Billing in the same application.

Enable Billing

To enable Billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling Billing for your application.

Clerk Billing costs the same as using Stripe Billing directly, just 0.7% per transaction, plus transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.

Payment gateway

Once you have enabled Billing, you will see the following Payment gateway options for collecting payments via Stripe:

  • Clerk development gateway: A shared test Stripe account used for development instances. This allows developers to test and build Billing flows in development without needing to create and configure a Stripe account.
  • Stripe account: Use your own Stripe account for production. A Stripe account created for a development instance cannot be used for production. You will need to create a separate Stripe account for your production environment.

Create a Plan

Subscription Plans are what your customers subscribe to. There is no limit to the number of Plans you can create. If your Clerk instance has existing Custom Permissions, the corresponding Features from those Permissions will automatically be added to the Free Plan for Organizations. This ensures that Organization members get the same set of Custom Permissions when Billing is enabled, because all Organizations start on the Free Plan.

To create a Plan, navigate to the Subscription plans page in the Clerk Dashboard. Here, you can create, edit, and delete Plans. To setup B2B Billing, select the Plans for Organizations tab and select Add Plan. When creating a Plan, you can also create Features for the Plan; see the next section for more information.

Tip

What is the Publicly available option?

Add Features to a Plan

Features make it easy to give entitlements to your Plans. You can add any number of Features to a Plan.

You can add a Feature to a Plan when you are creating a Plan. To add it after a Plan is created:

  1. In the Clerk Dashboard, navigate to the Subscription plans page.
  2. Select the Plan you'd like to add a Feature to.
  3. In the Features section, select Add Feature.

Tip

What is the Publicly available option?

Create a pricing page

You can create a pricing page by using the <PricingTable /> component. This component displays a table of Plans and Features that customers can subscribe to. It's recommended to create a dedicated page, as shown in the following example.

pages/pricing.vue
<script setup lang="ts">
import { PricingTable } from '@clerk/vue'
</script>

<template>
  <main>
    <PricingTable for="organization" />
  </main>
</template>

Control access with Features, Plans, and Permissions

You can use Clerk's Features, Plans, and Permissions to gate access to content using . There are a few ways to do this, but the recommended approach is to either use the has() method or the <Show> component.

Important

Permission-based authorization checks link with Feature-based authorization checks. This means that if you are checking a Custom Permission, it will only work if the Feature part of the Permission key (org:<feature>:<permission>) is a Feature included in the Organization's active Plan. For example, say you want to check if an Organization member has the Custom Permission org:teams:manage, where teams is the Feature. Before performing the authorization check, you need to ensure that the user's Organization is subscribed to a Plan that has the teams Feature. If the user's Organization is not subscribed to a Plan that has the teams Feature, the authorization check will always return false, even if the user has the Custom Permission.

Example: Using has()

Use the has() method to test if the Organization has access to a Plan:

const hasPremiumAccess = has({ plan: 'gold' })

Or a Feature:

const hasPremiumAccess = has({ feature: 'widgets' })

The has() method is a server-side helper that checks if the Organization has been granted a specific type of access control (Role, Permission, Feature, or Plan) and returns a boolean value. has() is available on the auth object, which you will access differently depending on the framework you are using.

Tip

Why aren't Custom Permissions appearing in the session token (JWT) or in API responses (including the result of the has() check)?

The following example demonstrates how to use has() to check if an Organization has a Plan.

src/bronze-content.vue
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'

const { isLoaded, has } = useAuth()
const hasBronzePlan = computed(() => has.value?.({ plan: 'bronze' }))
</script>

<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasBronzePlan">Only subscribers to the Bronze plan can access this content.</h1>
    <h1 v-else>For Bronze subscribers only</h1>
  </main>
</template>

The following example demonstrates how to use has() to check if an Organization has a Feature.

src/premium-content.vue
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'

const { isLoaded, has } = useAuth()
const hasPremiumAccess = computed(() => has.value?.({ feature: 'premium_access' }))
</script>

<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasPremiumAccess">
      Only subscribers with the Premium Access feature can access this content.
    </h1>
    <h1 v-else>Our Exclusive Content</h1>
  </main>
</template>

The following example demonstrates how to use has() to check if an Organization has a Permission.

src/manage-premium-content.vue
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'

const { isLoaded, has } = useAuth()
const hasPremiumAccessManage = computed(() =>
  has.value?.({ permission: 'org:premium_access:manage' }),
)
</script>

<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasPremiumAccessManage">
      Only subscribers with the Premium Access Manage permission can access this content.
    </h1>
    <h1 v-else>Our Exclusive Content</h1>
  </main>
</template>

Example: Using <Show>

The <Show> component can be used to protect content or even entire routes by checking if the Organization has been granted a specific type of access control (Role, Permission, Feature, or Plan). You can pass a fallback prop to <Show> that will be rendered if the Organization does not have the access control.

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Plan.

src/protected-content.vue
<script setup lang="ts">
import { Show } from '@clerk/vue'
</script>

<template>
  <main>
    <Show
      :when="{ plan: 'bronze' }"
      fallback="Only subscribers to the Bronze plan can access this content."
    >
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Show>
  </main>
</template>

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Feature.

src/protected-premium-content.vue
<script setup lang="ts">
import { Show } from '@clerk/vue'
</script>

<template>
  <main>
    <Show
      :when="{ feature: 'premium_access' }"
      fallback="Only subscribers with the Premium Access feature can access this content."
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Show>
  </main>
</template>

The following example demonstrates how to use <Show> to protect a page by checking if the Organization has a Permission.

src/protected-manage-content.vue
<script setup lang="ts">
import { Show } from '@clerk/vue'
</script>

<template>
  <main>
    <Show
      :when="{ permission: 'org:premium_access:manage' }"
      fallback="Only subscribers with the Premium Access Manage permission can access this content."
    >
      <h1>Exclusive Management Content</h1>
      <p>This content is only visible to users with Premium Access Manage permission.</p>
    </Show>
  </main>
</template>

Feedback

What did you think of this content?

Last updated on